/* *******************************************************************
   7.2@txL@
******************************************************************* */
#include<stdio.h>
#include<math.h>

/* LUTu[` */
float LUmatrix
(int n, float a[n+1][n+1], float U[n+1][n+1], float L[n+1][n+1]){
	int   i,j,k;
	float aa[n+1][n+1];

	/* zL̏ */
	for(j=1; j<=n; j++){
		for(i=1; i<=n; i++){
			L[i][j]=0.0;
		}
	}
	for(i=1; i<=n; i++){
		L[i][i]=1.0;
	}

	for(j=1; j<=n; j++){
		for(i=1; i<=n; i++){
			U[i][j]=a[i][j];
		}
	}

	for(j=1; j<=n-1; j++){
		for(i=j+1; i<=n; i++){
			L[i][j]=U[i][j]/U[j][j];
			for(k=j; k<=n; k++){
				aa[i][k]=U[i][k]-L[i][j]*U[j][k];
			}
		}
		for(i=j+1; i<=n; i++){
			for(k=j; k<=n; k++){
				U[i][k]=aa[i][k];
			}
		}
	}

	printf(" Upper triangular matrix\n");
	for(i=1; i<=n; i++){
		printf("%10.6f %10.6f %10.6f\n", U[i][1],U[i][2],U[i][3]);
	}
	printf("\n Lower triangular matrix\n");
	for(i=1; i<=n; i++){
		printf("%10.6f %10.6f %10.6f\n", L[i][1],L[i][2],L[i][3]);
	}
}

/* CvO */
int main(void){
	int   NM=4;
	int   i,j,k;
	float a[NM][NM],x[NM],y[NM],z[NM],U[NM][NM],L[NM][NM];
	float gosa,sum1,sum2;

	float EPS=1.0E-6;

	/* ASY菇PD*/
	int   n=3;
	a[1][1]=11.0; a[1][2]= 7.0; a[1][3]=-5.0;
	a[2][1]= 0.0; a[2][2]=10.0; a[2][3]=-1.0;
	a[3][1]= 2.0; a[3][2]= 8.0; a[3][3]= 3.0;
 
	/* l͓Kł悢A[xNgɂƌvZłȂ*/
	for(i=1; i<=n; i++){
		x[i]=1.0;
	}

	/* ASY菇QD*/
	LUmatrix(n,a,U,L);
	
	/* ASY菇RD*/
	int   kmax=200;
	float lambda=10000.0;  /* ɂ̏li_~[j*/
	float lambda2=10000.0;
	for(k=1; k<=kmax; k++){
		gosa=0.0;

		/* 菇R(1) LUy=x */
		/* @@@܂Lz=x */
		z[1]=x[1];
		for(j=2; j<=n; j++){
			sum1=x[j];
			for(i=1; i<=j-1; i++){
				sum1=sum1-L[j][i]*z[i];
			}
			z[j]=sum1;
		}
		/* @@@ÂUy=z */
		y[n]=z[n]/U[n][n];
		for(j=n-1; j>=1; j--){
			sum1=z[j];
			for(i=j+1; i<=n; i++){
				sum1=sum1-U[j][i]*y[i];
			}
			y[j]=sum1/U[j][j];
		}

		/* =(y,x)/(y,y) */
		sum1=0.0;
		sum2=0.0;
		for(i=1; i<=n; i++){
			sum1=sum1+y[i]*x[i];
			sum2=sum2+y[i]*y[i];
		}
		lambda=sum1/sum2;
		
		/* 菇R(2) */
		for(i=1; i<=n; i++){
			x[i]=y[i]/sqrt(sum2);
		}

		/* ASY菇SD*/
		gosa=fabsf(lambda-lambda2)/fabsf(lambda2);
		lambda2=lambda;
		if(gosa<EPS){
			printf("Converged!\n \n");
			break;
		}

		/* ʂ̏o */
		printf("k=%3d  lambda=%10.6f\n", k, lambda);
	}

	/* mmaxJԂĂȂꍇ */
	if(k>kmax){
		printf("It didn't converged.\n");
	}
	return 0;
}
